﻿package libs {
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import flash.media.SoundTransform;

	public class Clock {
		/*[Embed(source="../../res/clock.png")] private var res:Class;
		private var resBD:BitmapData;*/
		
		/*public function Clock(){
			var bmp:Bitmap = new res();
			resBD = bmp.bitmapData;
		}*/
		
		public var ext:Boolean = false;
		public var exti:uint = 0;
		public var exttxt:String = "";
		
		public var mpl:Boolean = true;
		
		private var cpos1:Number = 0;
		private var cpos2:Number = 0;
		
		private var lpos1:Number;
		private var lpos2:Number = 0;
		
		public function render(bd:BitmapData, time:uint):void {
			var tpos1:Number = Math.floor(time / 30);
			cpos1 = (cpos1 + tpos1 * 5) / 6;
			var tpos2:Number = Math.floor(time % 30 * 33.333);
			cpos2 = (cpos2 * 4 + tpos2) / 5;
			
			if (Math.round(tpos1) != lpos1){
				Thade.ats.sndClock1.play();
			} else if (Math.abs(Math.round(tpos2) - lpos2) >= 500){
				Thade.ats.sndClock2.play(0, 0, new SoundTransform(0.3));
				lpos2 = Math.round(tpos2);
			}
			
			lpos1 = Math.round(tpos1);
			
			// cpos1 = 10	1		0		0		0
			// =	9.9		0.99	0		9.11	9		0.11
			
			//var p11r:Number = cpos1 / 10;
			var p11:Number = Math.floor(cpos1 / 10);
			var p12:Number = cpos1 % 10;
			
			digits(bd, Math.floor(p11), Math.floor((p11 - Math.floor(p11)) * 8), 0);
			digits(bd, Math.floor(p12), Math.floor((p12 - Math.floor(p12)) * 8), 1);
			
			var p21:Number = cpos2 / 100;
			//var p22:Number = cpos2 - Math.floor(p21);
			var p22:Number = cpos2 % 10;
			
			digits(bd, Math.floor(p21), Math.floor((p21 - Math.floor(p21)) * 8), 3);
			digits(bd, Math.floor(p22), Math.floor((p22 - Math.floor(p22)) * 8), 4);
			
			/*var p1rnd:int = Math.floor(cpos1 * 8);
			var p2rnd:int = Math.floor(cpos2 * 8);*/
			
			/*digits(bd, Math.floor(p1rnd / 8), p1rnd % 8, 0);
			digits(bd, Math.floor(p2rnd / 8), p1rnd % 8, 1);*/
			
			/*if (srnd == 10){
				digits(bd, 1, 0, 0);
				digits(bd, 0, 0, 1);
			} else {
				digits(bd, 0, 0, 0);
				digits(bd, srnd, 0, 1);
			}
			
			var hrnd:int = Math.floor(time % 30 * 33.333);
			digits(bd, Math.floor(hrnd / 10), 0, 3);
			digits(bd, hrnd % 10, 0, 4);*/
			
			bd.copyPixels(Thade.ats.bdClock, new Rectangle(16, 0, 64, 16), new Point(256, 0), null, null, true);
			
			if (ext){
				bd.copyPixels(Thade.ats.bdClock, new Rectangle(0, 40, 32, 32), new Point(0, 0));
				if (exttxt != ""){
					bd.copyPixels(Thade.ats.bdMenusplash, new Rectangle(0, 240, 8, 16), new Point(32, 0));
					for (var j:uint = 0; j < exttxt.length; j++){
						bd.copyPixels(Thade.ats.bdMenusplash, new Rectangle(8, 240, 8, 16), new Point(40 + j * 8, 0));
					}
					bd.copyPixels(Thade.ats.bdMenusplash, new Rectangle(16, 240, 8, 16), new Point(40 + j * 8, 0));
					FontRenderer.render(bd, 40, 4, exttxt);
					
					bd.copyPixels(Thade.ats.bdClock, new Rectangle(0, 72 + exti * 32, 32, 32), new Point(0, 0), null, null, true);
				}
				bd.copyPixels(Thade.ats.bdClock, new Rectangle(32, 40, 24, 24), new Point(0, 0), null, null, true);
			}
		}
		
		private function digits(bd:BitmapData, d:uint, t:uint, pos:uint):void {
			var px1:uint = 0;
			var py1:uint = 0;
			
			var px2:uint = 0;
			var py2:uint = 0;
			
			switch (d){
				case 0:	px1 = 8;	py1 = 32;	px2 = 0;	py2 = 0; break;
				case 1:	px1 = 0;	py1 = 0;	px2 = 0;	py2 = 8; break;
				case 2:	px1 = 0;	py1 = 8;	px2 = 0;	py2 = 16; break;
				case 3:	px1 = 0;	py1 = 16;	px2 = 0;	py2 = 24; break;
				case 4:	px1 = 0;	py1 = 24;	px2 = 0;	py2 = 32; break;
				case 5:	px1 = 0;	py1 = 32;	px2 = 8;	py2 = 0; break;
				case 6:	px1 = 8;	py1 = 0;	px2 = 8;	py2 = 8; break;
				case 7:	px1 = 8;	py1 = 8;	px2 = 8;	py2 = 16; break;
				case 8:	px1 = 8;	py1 = 16;	px2 = 8;	py2 = 24; break;
				case 9:	px1 = 8;	py1 = 24;	px2 = 8;	py2 = 32; break;
			}
			
			//bd.copyPixels(resBD, new Rectangle(px1, py1 + t, 8, 8), new Point(264 + pos * 9, 4), null, null, true);
			bd.copyPixels(Thade.ats.bdClock, new Rectangle(px1, py1, 8, 8), new Point(264 + pos * 9, 4 - t), null, null, true);
			if (t > 0){
				bd.copyPixels(Thade.ats.bdClock, new Rectangle(px2, py2, 8, t), new Point(264 + pos * 9, 12 - t), null, null, true);
			}
		}
	}
}