﻿package libs {
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import flash.media.Sound;
	import flash.events.SampleDataEvent;
	import flash.media.SoundChannel;

	public class PNC {
		private var field:Vector.<uint>;
		private var fw:uint;
		private var fh:uint;
		
		private var walkmap:Vector.<Boolean>;
		//var walkfr:uint;
		
		private var tiles:Array; // tiles and entities
		
		private var px:uint; // player - tile x
		private var py:uint; // player - tile y
		
		private var rpi:uint = 0; // player entity id
		private var rpx:int = 0; // position offset
		private var rpy:int = 0;
		
		private var rpor:uint = 0; // player orientation
		
		private var cxc:int = 0; // camera
		private var cyc:int = 0;
		
		private var rcx:int = -12;
		private var rcy:int = 30;
		
		private var path:Array = new Array();
		private var ppos:Number = 0;
		private var pathtx:uint;
		private var pathty:uint;
		
		private var mr:Boolean = true; // mouse responsive
		
		var cm:BitmapData;
		
		/*public var exit:Boolean = false;
		public var exitnum:uint = 0;*/
		
		public var bgNoise:Boolean = false;
		
		private var bgNoiseSound:Boolean = false;
		private var bgNoiseSoundA:Sound;
		private var bgNoiseSoundB:Sound;
		
		private var bgNoiseSChA:SoundChannel;
		private var bgNoiseSChB:SoundChannel;
		
		private var exits:Array;
		private var exigp:Array;
		
		public function PNC(lvl:uint, exgp:Array){
			/*createField([0, 2, 4, 1, 1,
						 1, 3, 0, 0, 0,
						 1, 1, 1, 0xFF00, 0,
						 0, 0, 1, 1, 1, 
						 0, 1, 1, 0, 0], 5, 5);*/
			
			/*createField([0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						 0, 0, 0xFF00, 0xFF00, 4, 0, 0, 0, 0, 0,
						 0, 0, 2, 3, 2, 2, 2, 2, 2, 0,
						 0, 2, 2, 2, 2, 2, 2, 2, 2, 0,
						 0, 2, 2, 2, 2, 2, 2, 2, 0, 0,
						 2, 2, 1, 2, 2, 0xFF00, 0, 0, 0, 0,
						 0, 2, 2, 2, 0, 0, 0, 0, 0, 0], 10, 8);*/
			/*
			createField([0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						 0, 0, 0xFF00, 0xFF00, 4, 0, 0, 0, 0, 0,
						 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						 0, 0, 2, 2, 2, 0, 0, 0, 0, 0,
						 0, 2, 2, 1, 2, 2, 0, 0, 0, 0,
						 0, 0, 0, 2, 0, 0, 0, 0, 0, 0,
						 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], 10, 8);*/
						/* 
			createField([0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						 0, 0, 0xFF01, 0, 4, 0, 0, 0, 0, 0,
						 0, 0, 2, 3, 2, 2, 2, 2, 2, 0,
						 0, 2, 2, 2, 2, 2, 2, 2, 2, 0,
						 0, 2, 2, 2, 2, 2, 2, 2, 0, 0,
						 2, 2, 1, 2, 2, 0, 0, 0, 0, 0,
						 0, 2, 2, 2, 0, 0, 0, 0, 0, 0], 10, 8);*/
			//trace(lvl);
			switch (lvl){
				case 0:
				createField([0, 0, 12, 0, 7, 0, 13, 0, 0, 0,
							 0, 12, 7, 7, 2, 7, 7, 13, 0, 0,
							 7, 7, 2, 2, 7, 2, 2, 7, 7, 0,
							 7, 7, 7, 2, 2, 2, 7, 7, 7, 0,
							 7, 7, 2, 2, 7, 2, 2, 7, 7, 0,
							 0, 7, 7, 2, 2, 2, 7, 7, 0, 0,
							 0, 15, 15, 7, 7, 7, 14, 14, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], 10, 8);
				tiles[rpi][0] = 4;
				tiles[rpi][1] = 2;
				rcx = -12;
				rcy = 0;
				break;
				case 1:
				case 2:
				createField([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xFF06, 0xFF06, 0xFF06, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0xFF06, 0xFF06, 9, 9, 9, 0xFF06, 0xFF06, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0xFF06, 0xFF06, 9, 9, 9, 9, 9, 9, 9, 0xFF06, 0xFF06, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0xFF06, 0xFF06, 9, 9, 9, 9, 0, 9, 9, 9, 9, 9, 9, 0xFF06, 0xFF06, 0, 0, 0,
							 0, 0, 0xFF06, 0xFF06, 9, 9, 9, 9, 0, 0, (lvl == 1 ? 0xFF03 : 0xFF04), 0, 0, 9, 9, 9, 9, 9, 9, 0xFF06, 0xFF06, 0,
							 0, 0xFF06, 9, 9, 9, 9, 9, 0, 0, 0, 0, 0, 0, 0, 9, 9, 9, 9, 9, 9, 9, 0xFF06,
							 0, 0, 0, 9, 9, 9, 9, 9, 9, 0, 0, 0, 9, 9, 9, 9, 9, 9, 9, 9, 0, 0,
							 0, 0, 0, 0, 0, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 9, 9, 9, 9, 9, 9, 9, 9, 9, 10, 10, 10, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 9, 9, 9, 9, 0, 0, 0, 10, 10, 10, 11, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], 22, 15);
				tiles[rpi][0] = 18;
				tiles[rpi][1] = 8;
				rcx = -12;
				rcy = 30;
				break;
				case 3:
				case 4:
				createField([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xFF08, 0xFF08, (lvl == 3 ? 0xFF07 : 0xFF09), 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xFF08, 0xFF08, 10, 10, 10, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xFF08, 0xFF08, 10, 10, 10, 10, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0xFF08, 0xFF08, 10, 10, 10, 10, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0xFF08, 0xFF08, 10, 10, 10, 10, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0xFF08, 0xFF08, 10, 10, 10, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0xFF08, 0xFF08, 10, 10, 10, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 10, 10, 10, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 16, 16, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], 19, 15);
				tiles[rpi][0] = 2;
				tiles[rpi][1] = 12;
				rcx = -12;
				rcy = 30;
				break;
				case 5:
				case 6:
				createField([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xFF02, 0xFF02, 0xFF02, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0xFF02, 0xFF02, 7, 7, 7, 0xFF02, 0xFF02, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0xFF02, 0xFF02, 7, 7, 0, 0, 0, 7, 7, 0xFF02, 0xFF02, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0xFF02, 0xFF02, 7, 7, 0, 0, 0, (lvl == 5 ? 0xFF01 : 0xFF05), 0, 0, 0, 7, 7, 0xFF02, 0xFF02, 0, 0, 0,
							 0, 0, 0xFF02, 0xFF02, 7, 7, 7, 7, 7, 0, 0, 0, 0, 0, 7, 7, 7, 7, 7, 0xFF02, 0xFF02, 0,
							 0, 0xFF02, 7, 7, 6, 7, 7, 7, 7, 7, 7, 0, 7, 7, 7, 7, 7, 7, 6, 7, 7, 0xFF02,
							 0, 0, 0, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 0, 0,
							 0, 0, 0, 0, 0, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 0, 0, 0, 0,
							 0, 0, 0, 0, 5, 5, 5, 7, 7, 7, 7, 7, 7, 7, 7, 7, 0, 0, 0, 0, 0, 0,
							 0, 0, 8, 5, 5, 5, 0, 0, 0, 7, 7, 6, 7, 7, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], 22, 15);
				tiles[rpi][0] = 4;
				tiles[rpi][1] = 8;
				rcx = -12;
				rcy = 30;
				if (lvl == 5){
					bgNoise = true;
					bgNoiseStart();
				}
				break;
				case 7:
				createField([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0xFF06, 0xFF06, 0xFF06, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0xFF06, 0xFF06, 9, 9, 9, 0xFF06, 0xFF06, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0xFF06, 0xFF06, 9, 9, 9, 9, 9, 9, 9, 0xFF06, 0xFF06, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0xFF06, 0xFF06, 9, 9, 9, 9, 0, 9, 9, 9, 9, 9, 9, 0xFF06, 0xFF06, 0, 0, 0,
							 0, 0, 0xFF06, 0xFF06, 9, 9, 9, 9, 0, 0, 0xFF0A, 0, 0, 9, 9, 9, 9, 9, 9, 0xFF06, 0xFF06, 0,
							 0, 0xFF06, 9, 9, 9, 9, 9, 0, 0, 0, 0, 0, 0, 0, 9, 9, 9, 9, 9, 9, 9, 0xFF06,
							 0, 0, 0, 9, 9, 9, 9, 9, 9, 0, 0, 0, 9, 9, 9, 9, 9, 9, 9, 9, 0, 0,
							 0, 0, 0, 0, 0, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 9, 9, 9, 9, 9, 9, 9, 9, 9, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 9, 9, 9, 9, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], 22, 15);
				tiles[rpi][0] = 11;
				tiles[rpi][1] = 8;
				rcx = -12;
				rcy = 30;
				break;
			}
			cxc = -(tiles[rpi][0] * 16 + 8 + rpx);
			cyc = -((tiles[rpi][1] * 16 + (tiles[rpi][0] % 2 == 0 ? 8 : 0)) - 16 + rpy);
			
			exigp = exgp;
		}
		
		public function render(bd:BitmapData):void {
			var i:uint;
			
			var xp:uint = 0;
			var yp:uint = 0;
			
			cm = new BitmapData(320, 240, true, 0x00FFFFFF);
			var cmd:BitmapData = new BitmapData(32, 16, true, 0x00FFFFFF);
			cmd.copyPixels(Thade.ats.bdPNC, new Rectangle(0, 0, 32, 16), new Point(0, 0), null, null, true);
			
			var pt:Point;
			
			if (bgNoise){
				bd.noise(StaticPRNG.nextIntMod(800), 0, 255, 7, true);
			}
			
			if (path.length > 0){
				if (ppos >= 1){
					tiles[rpi][0] = path[0][0];
					tiles[rpi][1] = path[0][1];
					path.shift();
					ppos = 0;
					rpx = 0;
					rpy = 0;
					for (i = 0; i < exits.length; i++){
						if (exits[i][0] == tiles[rpi][0] && exits[i][1] == tiles[rpi][1]){
							//exit = true;
							var tg:uint = exigp[exits[i][2]][0];
							if (tg == 1 && Thade.inv.hasOwnProperty("m_h")){
								tg = 3;
							} else if (tg == 7 && Thade.inv.hasOwnProperty("key")){
								tg = 9;
							}
							Thade.sGP(tg, exigp[exits[i][2]][1]);
							//exitnum = exits[i][2];
							mr = false;
						}
					}
				} else {
					ppos += 0.2;
					pt = new Point(path[0][0] * 16, (path[0][1] * 16 + (path[0][0] % 2 == 0 ? 8 : 0)));
					var ptn:Point = new Point(tiles[rpi][0] * 16, (tiles[rpi][1] * 16 + (tiles[rpi][0] % 2 == 0 ? 8 : 0)));
					rpx = (pt.x * ppos + ptn.x * (1 - ppos)) - ptn.x;
					rpy = (pt.y * ppos + ptn.y * (1 - ppos)) - ptn.y;
					
					rpor = 0;
					if (pt.y < ptn.y){
						rpor += 2;
					}
					if (pt.x < ptn.x){
						rpor += 1;
					}
				}
				
				sortTiles();
			}
			
			var cxt:int = -(tiles[rpi][0] * 16 + 8 + rpx);
			var cyt:int = -((tiles[rpi][1] * 16 + (tiles[rpi][0] % 2 == 0 ? 8 : 0)) - 16 + rpy);
			
			cxc = Math.round((cxc * 7 + cxt) / 8);
			cyc = Math.round((cyc * 7 + cyt) / 8);
			
			for (i = 0; i < tiles.length; i++){
				switch (tiles[i][4]){
					case 0: // tile
					pt = new Point(tiles[i][0] * 16 + cxc + 160 + rcx, (tiles[i][1] * 16 + (tiles[i][0] % 2 == 0 ? 8 : 0)) + cyc + 120 + rcy);
					bd.copyPixels(Thade.ats.bdPNC, new Rectangle(field[tiles[i][3]] * 32, 0, 32, 32), pt, null, null, true);
					cmd.threshold(cmd, cmd.rect, new Point(0, 0), ">=", 0xFF000000, 0xFF000000 | i);
					cm.copyPixels(cmd, cmd.rect, pt, null, null, true);
					break;
					case 1: // entity
					//pt = new Point(tiles[i][0] * 16 + cxc + 160, (tiles[i][1] * 16 + (tiles[i][0] % 2 == 0 ? 8 : 0)) + cyc + 120);
					pt = new Point(tiles[i][9] + tiles[i][0] * 16 + cxc + 160 + rcx, tiles[i][10] + (tiles[i][1] * 16 + (tiles[i][0] % 2 == 0 ? 8 : 0)) + cyc + 120 + rcy);
					bd.copyPixels(Thade.ats.bdPNC, new Rectangle(tiles[i][5], tiles[i][6], tiles[i][7], tiles[i][8]), pt, null, null, true);
					
					var ecm:BitmapData = new BitmapData(tiles[i][7], tiles[i][8], true, 0x00FFFFFF);
					ecm.threshold(Thade.ats.bdPNC, new Rectangle(tiles[i][5], tiles[i][6], tiles[i][7], tiles[i][8]), new Point(0, 0), ">=", 0x80000000, 0xFF000000 | i);
					cm.copyPixels(ecm, ecm.rect, pt, null, null, true);
					
					break;
					case 2: // player
					pt = new Point(tiles[i][0] * 16 + 8 + rpx + cxc + 160 + rcx, (tiles[i][1] * 16 + (tiles[i][0] % 2 == 0 ? 8 : 0)) - 16 + rpy + cyc + 120 + rcy);
					bd.copyPixels(Thade.ats.bdPNC, new Rectangle(0, 104 + 24 * rpor, 16, 24), pt, null, null, true);
					break;
				}
				
				/*xp++;
				if (xp == fw){
					xp = 0;
					yp++;
				}*/
			}
		}
		
		public function bgNoiseStart():void {
			if (!bgNoiseSound){
				bgNoiseSoundA = new Sound();
				bgNoiseSoundB = new Sound();
				
				bgNoiseSoundA.addEventListener(SampleDataEvent.SAMPLE_DATA, bgNoiseSampleA);
				bgNoiseSoundB.addEventListener(SampleDataEvent.SAMPLE_DATA, bgNoiseSampleB);
				
				bgNoiseSChA = bgNoiseSoundA.play();
				bgNoiseSChB = bgNoiseSoundB.play();
				bgNoiseSound = true;
			}
		}
		
		public function bgNoiseStop():void {
			if (bgNoiseSound){
				bgNoiseSChA.stop();
				bgNoiseSChB.stop();
				bgNoiseSound = false;
			}
		}
		
		private function bgNoiseSampleA(e:SampleDataEvent):void {
			for (var i:uint = 0; i < 8192; i++){
				e.data.writeFloat(StaticPRNG.nextDouble() * 0.25);
				e.data.writeFloat(StaticPRNG.nextDouble() * 0.25);
			}
		}
		
		private function bgNoiseSampleB(e:SampleDataEvent):void {
			for (var i:uint = 0; i < 8192; i++){
				var n:Number = Math.sin((i + e.position) / Math.PI / 2);
				e.data.writeFloat(n * 0.15);
				e.data.writeFloat(n * 0.15);
			}
		}
		
		public function mclick():void {
			var i:uint;
			
			if (Thade.s.mouseX > 0 && Thade.s.mouseX < 640 && Thade.s.mouseY > 0 && Thade.s.mouseY < 480 && mr){
				var cat:uint = cm.getPixel32(Thade.s.mouseX >> 1, Thade.s.mouseY >> 1);
				var mc:uint = cat & 0xFFFFFF;
				var cx:uint = tiles[rpi][0];
				var cy:uint = tiles[rpi][1];
				if (mc != 0){
					if (tiles[mc][4] == 1){
						if (Math.abs(tiles[mc][0] - cx) < 6 && Math.abs(tiles[mc][1] - cy) < 6){
							switch (tiles[mc][11]){
								case 1:
								if (Thade.inv.hasOwnProperty("m_h")){
									Thade.sGP(8, 0);
								}
								break;
								case 3:
								Thade.sGP(2, 0);
								break;
								case 7:
								if (Thade.inv.hasOwnProperty("key")){
									Thade.sGP(5, 0);
								}
								break;
								case 10:
								if (Thade.inv.hasOwnProperty("pulse")){
									Thade.sGP(12, 0);
								}
								break;
							}
						}
						return;
					}
					
					if (path.length > 0){
						return;
					}
					
					pathtx = tiles[mc][0];
					pathty = tiles[mc][1];
					
					var ptvis:Point = new Point(pathtx * 16, (pathty * 16 + (pathtx % 2 == 0 ? 8 : 0)));
					
					if ((pathtx != cx || pathty != cy) && Math.abs(cx - pathtx) < 7 && Math.abs(cy - pathty) < 5){
						var unexp:Array = new Array(new Array(cx, cy, cx + cy * fw, false, false));
						var unexpc:uint = 1;
						
						// x even
						var nghb1:Array = [[0, -1, -fw],
										   [-2, 0, -2],
										   [-1, 0, -1],
										   [1, 0, 1],
										   [2, 0, 2],
										   [-1, 1, fw - 1],
										   [0, 1, fw],
										   [1, 1, fw + 1]];
						// x odd
						var nghb2:Array = [[0, -1, -fw],
										   [-2, 0, -2],
										   [-1, 0, -1],
										   [1, 0, 1],
										   [2, 0, 2],
										   [-1, -1, -fw - 1],
										   [0, 1, fw],
										   [1, -1, -fw + 1]];
						
						var pfo:Boolean = false;
						var infsave:uint = 0;
						while (unexpc > 0 && !pfo && infsave++ < 500){
							for (i = 0; i < unexp.length; i++){
								if (unexp[i][3] == false){
									break;
								}
							}
							if (i == unexp.length){
								break;
							}
							unexp[i][3] = true;
							unexpc--;
							
							var unghb:Array = new Array();
							var pt:Point;
							for (var j:uint = 0; j < nghb1.length; j++){
								//unghb[j] = nghb[1];
								unghb[j] = new Array();
								if (unexp[i][0] % 2 == 0){
									unghb[j][0] = (nghb1[j][0] + unexp[i][0]) - pathtx;
									unghb[j][1] = (nghb1[j][1] + unexp[i][1]) - pathty;
									unghb[j][2] = nghb1[j];
								} else {
									unghb[j][0] = (nghb2[j][0] + unexp[i][0]) - pathtx;
									unghb[j][1] = (nghb2[j][1] + unexp[i][1]) - pathty;
									unghb[j][2] = nghb2[j];
								}
								unghb[j][3] = new Point(unghb[j][0] * 16, (unghb[j][1] * 16 + (unghb[j][0] % 2 == 0 ? 8 : 0)));
							}
							
							unghb.sort(heurSort);
							
							for (j = 0; (j < unghb.length) && !pfo; j++){
								if ((unexp[i][0] + unghb[j][2][0]) >= 0 && (unexp[i][0] + unghb[j][2][0]) < fw && (unexp[i][1] + unghb[j][2][1]) >= 0 && (unexp[i][1] + unghb[j][2][1]) < fh){
									if (walkmap[unexp[i][2] + unghb[j][2][2]]){
										unexp[unexp.length] = new Array(unexp[i][0] + unghb[j][2][0], unexp[i][1] + unghb[j][2][1], unexp[i][2] + unghb[j][2][2], false, i);
										unexpc++;
										if ((unexp[i][0] + unghb[j][2][0] == pathtx) && (unexp[i][1] + unghb[j][2][1] == pathty)){
											pfo = true;
										}
									}
								}
							}
						}
						
						if (pfo){
							var sw:Array = new Array();
							if (path.length > 0){
								sw = path[0];
							}
							
							path = new Array();
							
							var cpos:Array = unexp[unexp.length - 1];
							path.unshift(new Array(cpos[0], cpos[1], cpos[2]));
							
							while (cpos[4] != false){
								cpos = unexp[cpos[4]];
								path.unshift(new Array(cpos[0], cpos[1], cpos[2]));
							}
							
							if (sw.length > 0){
								path.unshift(sw);
							}
						}
					}
					
					//rpx = tiles[mc][0] * 16 + 8;
					//rpy = (tiles[mc][1] * 16 + (tiles[mc][0] % 2 == 0 ? 8 : 0)) - 16;
					//tiles[rpi][0] = tiles[mc][0];
					//tiles[rpi][1] = tiles[mc][1];
					//field[tiles[cat & 0xFFFFFF][2]] ^= 1;
					//tiles.sort(zSort);
					/*for (var i:uint = 0; i < tiles.length; i++){
						if (tiles[i][4] == 2){
							rpi = i;
							return;
						}
					}*/
				}
			}
		}
		
		private function createField(m:Array, w:uint, h:uint):void {
			var i:uint;
			var xp:uint = 0;
			var yp:uint = 0;
			
			fw = w;
			fh = h;
			
			field = new Vector.<uint>(w * h);
			walkmap = new Vector.<Boolean>(field.length);
			tiles = new Array();
			exits = new Array();
			for (i = 0; i < m.length; i++){
				field[i] = m[i];
				walkmap[i] = false;
				
				// xpos, ypos, zpos, index, type
				if (field[i] > 0 && field[i] < 0xFF00){
					var pow:Boolean = true;
					switch (field[i]){
						case 8:
						exits[exits.length] = new Array(xp, yp, 0);
						break;
						case 11:
						exits[exits.length] = new Array(xp, yp, 0);
						break;
						case 12:
						case 13:
						case 14:
						exits[exits.length] = new Array(xp, yp, field[i] - 12);
						break;
						case 15:
						pow = false;
						if (Thade.inv.hasOwnProperty("pulse")){
							pow = true;
							exits[exits.length] = new Array(xp, yp, field[i] - 12);
						}
						break;
						case 16:
						exits[exits.length] = new Array(xp, yp, 0);
						break;
						default:
					}
					if (pow){
						tiles[tiles.length] = new Array(xp, yp, 0, i, 0);
						walkmap[i] = true;
					}
				} else if (field[i] >= 0xFF00){
					switch (field[i]){
						case 0xFF00: // bar test
						tiles[tiles.length] = new Array(xp, yp, 1, i, 1, 0, 32, 32, 48, 0, -32, 0);
						break;
						case 0xFF01: // statue - heartless
						tiles[tiles.length] = new Array(xp, yp, 1, i, 1, 32, 48, 160, 176, -80, -112, 1);
						break;
						case 0xFF02: // bar white
						tiles[tiles.length] = new Array(xp, yp, 0, i, 1, 224, 32, 32, 144, 0, -112, 2);
						break;
						case 0xFF03: // vault closed
						tiles[tiles.length] = new Array(xp, yp, 1, i, 1, 32, 224, 160, 176, -80, -112 + 32, 3);
						break;
						case 0xFF04: // vault open
						tiles[tiles.length] = new Array(xp, yp, 1, i, 1, 64 + 128, 224, 128, 176, -80 + 32, -112 + 32, 4);
						break;
						case 0xFF05: // statue - heartful
						tiles[tiles.length] = new Array(xp, yp, 1, i, 1, 272+16, 48, 160-8, 176, -80 + 16, -112, 5);
						break;
						case 0xFF06: // bar red
						tiles[tiles.length] = new Array(xp, yp, 0, i, 1, 256, 32, 32, 144, 0, -112, 6);
						break;
						case 0xFF07: // doors
						tiles[tiles.length] = new Array(xp, yp, 0, i, 1, 440, 32, 56, 64, -8, -32, 7);
						break;
						case 0xFF08: // bar red small
						tiles[tiles.length] = new Array(xp, yp, 0, i, 1, 496, 40, 56, 64, 0, -32, 8);
						break;
						case 0xFF09: // doors open
						tiles[tiles.length] = new Array(xp, yp, 0, i, 1, 440, 96, 56, 64, -8, -32, 9);
						break;
						case 0xFF0A: // heart
						tiles[tiles.length] = new Array(xp, yp, 1, i, 1, 256 + 64, 224, 128, 176, -80 + 32, -112 + 32, 10);
						break;
					}
				}
				
				xp++;
				if (xp == fw){
					xp = 0;
					yp++;
				}
			}
			
			tiles[tiles.length] = new Array(0, 0, 1, false, 2);
			
			sortTiles();
		}
		
		private function sortTiles():void {
			tiles.sort(zSort);
			for (var i:uint = 0; i < tiles.length; i++){
				if (tiles[i][4] == 2){
					rpi = i;
					break;
				}
			}
		}
		
		private function zSort(a:*, b:*):Number {
			if (a[2] > b[2]){
				return 1;
			} else if (b[2] > a[2]){
				return -1;
			}
			
			var ap:Point = new Point(a[0] * 16, (a[1] * 16 + (a[0] % 2 == 0 ? 8 : 0)));
			var bp:Point = new Point(b[0] * 16, (b[1] * 16 + (b[0] % 2 == 0 ? 8 : 0)));
			
			if (ap.y < bp.y){
				return -1;
			} else {
				return 1;
			}
		}
		
		private function heurSort(a:*, b:*):Number {
			/*var tda:int = (a[0] > 0 ? a[0] : -a[0]) + (a[1] > 0 ? a[1] : -a[1]);
			var tdb:int = (b[0] > 0 ? b[0] : -b[0]) + (b[1] > 0 ? b[1] : -b[1]);*/
			/*
			if (((a[0] > 0 ? a[0] : -a[0]) + (a[1] > 0 ? a[1] : -a[1])) < ((b[0] > 0 ? b[0] : -b[0]) + (b[1] > 0 ? b[1] : -b[1]))){
				return -1;
			} else {
				return 1;
			}*/
			
			if (((a[3].x > 0 ? a[3].x : -a[3].x) + (a[3].y > 0 ? a[3].y : -a[3].y)) < ((b[3].x > 0 ? b[3].x : -b[3].x) + (b[3].y > 0 ? b[3].y : -b[3].y))){
				return -1;
			} else {
				return 1;
			}
		}
	}
}