﻿package libs {
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.media.Sound;

	public class Assets {
		[Embed(source="../../res/zones.png")] private var rcZones:Class;
		public var bdZones:BitmapData;
		[Embed(source="../../res/font.png")] private var rcFont:Class;
		public var bdFont:BitmapData;
		[Embed(source="../../res/pipes.png")] private var rcPipes:Class;
		public var bdPipes:BitmapData;
		[Embed(source="../../res/clock.png")] private var rcClock:Class;
		public var bdClock:BitmapData;
		[Embed(source="../../res/pnc.png")] private var rcPNC:Class;
		public var bdPNC:BitmapData;
		[Embed(source="../../res/lightsout.png")] private var rcLightsout:Class;
		public var bdLightsout:BitmapData;
		[Embed(source="../../res/menusplash.png")] private var rcMenusplash:Class;
		public var bdMenusplash:BitmapData;
		
		//[Embed(source="../../res/sfx_heartbeat2.wav")] private var rcSFXheart:Class;
		public var sndHeart:Sound;
		public var sndShuff:Sound;
		public var sndClock1:Sound;
		public var sndClock2:Sound;
		public var sndLevel:Sound;
		
		public function Assets(lib:Array){
			var bmp:Bitmap = new rcZones();
			bdZones = bmp.bitmapData;
			bmp = new rcFont();
			bdFont = bmp.bitmapData;
			bmp = new rcPipes();
			bdPipes = bmp.bitmapData;
			bmp = new rcClock();
			bdClock = bmp.bitmapData;
			bmp = new rcPNC();
			bdPNC = bmp.bitmapData;
			bmp = new rcLightsout();
			bdLightsout = bmp.bitmapData;
			bmp = new rcMenusplash();
			bdMenusplash = bmp.bitmapData;
			
			sndHeart = new (lib[0])();
			sndShuff = new (lib[1])();
			sndClock1 = new (lib[2])();
			sndClock2 = new (lib[3])();
			sndLevel = new (lib[4])();
		}
	}
}